require 'nkf'
require 'util'

def mkdat
  users = Array.new
  Dir.glob('*.sync').each do |user|
    if (Time.now - File.mtime(user) > 60)
      File.unlink(user)
    else
      users.push(unescape(user.sub(/.sync$/, '')))
    end
  end
  if (ENV['HTTP_HOST'] == 'shinh.skr.jp')
    users.push('mircbot')
  end

  File.open('users.db', 'w') do |ufile|
    ufile.flock(File::LOCK_EX)
    require 'pstore'
    db = PStore.new('typing.db')
    db.transaction(true) do
      ustr = users.sort.map do |u|
        if db.root?(u)
          "<li>#{u}(#{url(db[u])})"
        else
          "<li>#{u}"
        end
      end.join(', ')
      ufile.puts('<p>ü: <ul>' + NKF.nkf('-We', ustr) + '</ul></p>')
    end
  end

  File.open('dat.db', 'w') do |ofile|
    ofile.flock(File::LOCK_EX)
    ret = ''
    File.open('users.db', 'r') do |i|
      i.flock(File::LOCK_SH)
      ret += i.read
      i.flock(File::LOCK_UN)
    end
    if File.exist?('topic.db')
      File.open('topic.db', 'r') do |i|
        i.flock(File::LOCK_SH)
        ret += i.read
        i.flock(File::LOCK_UN)
      end
    end
    File.open('chat.db', 'r') do |i|
      i.flock(File::LOCK_SH)
      r = i.readlines.reverse
      i.flock(File::LOCK_UN)
      r = r[0...20].inject('') {|p,l| "#{p}<li>#{l}"}
      ret += '<ul>' + r  + '</ul>'
    end
    ofile.puts ret
    ofile.flock(File::LOCK_UN)
  end

  Dir.glob('*.pid').each do |pid|
    pidi = pid.sub(/.pid$/, '').to_i
    begin
      Process.kill(:USR1, pidi)
    rescue
      File.unlink(pid)
    end
  end
end
