#!/usr/bin/env ruby

require 'open-uri'
require 'nkf'

rss = open('http://www3.asahi.com/rss/index.rdf')
r = rss.read
r =~ /<item rdf:about="([^"]+)">\s+<title>([^<]+)</
url = $1
title = NKF.nkf('-We', $2)

prevurl = File.open('prevnews') do |ifile|
  ifile.read
end

exit 0 if (prevurl.chomp == url)

File.open('prevnews', 'w') do |ofile|
  ofile.puts(url)
end

File.open('chat.db', 'a') do |ofile|
  ofile.flock(File::LOCK_EX)
  ofile.puts(Time.now.strftime('%H:%M:%S') + %Q( ˥塼: <a href="#{url}">#{title}</a>))
end

require 'mkdat'
mkdat()
