#!/usr/bin/env ruby

require 'read'
require 'util'

require 'nkf'

if ENV['QUERY_STRING'] =~ /^msg=(.*)/
  msg = url(unescape($1).gsub(/&/, '&amp;').gsub(/</, '&lt;').gsub(/>/, '&gt;'))
  File.open('chat.db', 'a') do |ofile|
    ofile.flock(File::LOCK_EX)
    msg = NKF.nkf('-We', msg)
    ofile.puts(Time.now.strftime('%H:%M:%S') + " " + msg)

    # mirc
    if (ENV['HTTP_HOST'] == 'shinh.skr.jp')
      if (msg =~ /^([^:]+): ([a-zA-Z!]+)&gt;(.*)/)
        name = $1
        cmd = $2
        arg = $3
        class DummyContext
          attr_accessor :nick
        end
        @context = DummyContext.new
        @context.nick = name
        require 'mirc'
        ret = mirc(cmd, arg)
        if (ret)
          if (ret.class == Array)
            ret.each do |r|
              ofile.puts(Time.now.strftime('%H:%M:%S') + " mircbot: " + url(r))
            end
          else
            ofile.puts(Time.now.strftime('%H:%M:%S') + " mircbot: " + url(ret))
          end
        end
      end
    end

    ofile.flock(File::LOCK_UN)
  end
elsif ENV['QUERY_STRING'] =~ /^topic=(.*)/
  msg = unescape($1).gsub(/&/, '&amp;').gsub(/</, '&lt;').gsub(/>/, '&gt;')
  File.open('topic.db', 'w') do |ofile|
    ofile.flock(File::LOCK_EX)
    ofile.puts('<p>ȥԥå: ' + NKF.nkf('-We', msg) + '</p>')
    ofile.flock(File::LOCK_UN)
  end
elsif ENV['QUERY_STRING'] =~ /^typing=(.*)/
  msg = unescape($1).gsub(/&/, '&amp;').gsub(/</, '&lt;').gsub(/>/, '&gt;')
  msg =~ /^([^:]+):(.*)/
  user = $1
  msg = $2
  require 'pstore'
  typing = PStore.new('typing.db')
  typing.transaction do
    typing[user] = msg
  end
else
  exit 0
end

require 'mkdat'
mkdat()

print "Content-Type: text/plain; charset=EUC-JP\r\n"
print "Cache-Control: no-cache\r\n"
print "Pragma: no-cache\r\n"
print "\r\n"
puts read_chat()
